Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

All Data Structures Namespaces Files Functions Variables Typedefs Enumerations Enumerator Macros Pages
Public Member Functions | Static Public Member Functions
Lucene::QueryParserCharStream Class Referenceabstract

This interface describes a character stream that maintains line and column number positions of the characters. It also has the capability to backup the stream to some extent. An implementation of this interface is used in the QueryParserTokenManager. More...

`#include <QueryParserCharStream.h>`

Inheritance diagram for Lucene::QueryParserCharStream:

## Public Member Functions

virtual String | getClassName ()
virtual wchar_t | readChar ()=0
| Returns the next character from the selected input. The method of selecting the input is the responsibility of the class implementing this interface. More...
virtual int32_t | getColumn ()=0
| Returns the column position of the character last read. More...
virtual int32_t | getLine ()=0
| Returns the line number of the character last read. More...
virtual int32_t | getEndColumn ()=0
| Returns the column number of the last character for current token (being matched after the last call to BeginToken). More...
virtual int32_t | getEndLine ()=0
| Returns the line number of the last character for current token (being matched after the last call to BeginToken). More...
virtual int32_t | getBeginColumn ()=0
| Returns the column number of the first character for current token (being matched after the last call to BeginToken). More...
virtual int32_t | getBeginLine ()=0
| Returns the line number of the first character for current token (being matched after the last call to BeginToken). More...
virtual void | backup (int32_t amount)=0
| Backs up the input stream by amount steps. Lexer calls this method if it had already read some characters, but could not use them to match a (longer) token. So, they will be used again as the prefix of the next token and it is the implementation's's responsibility to do this right. More...
virtual wchar_t | BeginToken ()=0
| Returns the next character that marks the beginning of the next token. All characters must remain in the buffer between two successive calls to this method to implement backup correctly. More...
virtual String | GetImage ()=0
| Returns a string made up of characters from the marked token beginning to the current buffer position. Implementations have the choice of returning anything that they want to. For example, for efficiency, one might decide to just return null, which is a valid implementation. More...
virtual CharArray | GetSuffix (int32_t length)=0
| Returns an array of characters that make up the suffix of length for the currently matched token. This is used to build up the matched string for use in actions in the case of MORE. More...
virtual void | Done ()=0
| The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class. Again, the body of this function can be just empty and it will not affect the lexer's operation. More...

## Static Public Member Functions

static String | _getClassName ()

## Detailed Description

This interface describes a character stream that maintains line and column number positions of the characters. It also has the capability to backup the stream to some extent. An implementation of this interface is used in the QueryParserTokenManager.

All the methods except backup can be implemented in any fashion. backup needs to be implemented correctly for the correct operation of the lexer. Rest of the methods are all used to get information like line number, column number and the String that constitutes a token and are not used by the lexer. Hence their implementation won't affect the generated lexer's operation.

## Member Function Documentation

static String Lucene::QueryParserCharStream::_getClassName | ( | ) |  |

inline static

virtual void Lucene::QueryParserCharStream::backup | ( | int32_t | amount) |  |

pure virtual

Backs up the input stream by amount steps. Lexer calls this method if it had already read some characters, but could not use them to match a (longer) token. So, they will be used again as the prefix of the next token and it is the implementation's's responsibility to do this right.

Implemented in Lucene::FastCharStream.

virtual wchar_t Lucene::QueryParserCharStream::BeginToken | ( | ) |  |

pure virtual

Returns the next character that marks the beginning of the next token. All characters must remain in the buffer between two successive calls to this method to implement backup correctly.

Implemented in Lucene::FastCharStream.

virtual void Lucene::QueryParserCharStream::Done | ( | ) |  |

pure virtual

The lexer calls this function to indicate that it is done with the stream and hence implementations can free any resources held by this class. Again, the body of this function can be just empty and it will not affect the lexer's operation.

Implemented in Lucene::FastCharStream.

virtual int32_t Lucene::QueryParserCharStream::getBeginColumn | ( | ) |  |

pure virtual

Returns the column number of the first character for current token (being matched after the last call to BeginToken).

Implemented in Lucene::FastCharStream.

virtual int32_t Lucene::QueryParserCharStream::getBeginLine | ( | ) |  |

pure virtual

Returns the line number of the first character for current token (being matched after the last call to BeginToken).

Implemented in Lucene::FastCharStream.

virtual String Lucene::QueryParserCharStream::getClassName | ( | ) |  |

inline virtual

Reimplemented in Lucene::FastCharStream.

virtual int32_t Lucene::QueryParserCharStream::getColumn | ( | ) |  |

pure virtual

Returns the column position of the character last read.

Deprecated:

See Also
  getEndColumn

Implemented in Lucene::FastCharStream.

virtual int32_t Lucene::QueryParserCharStream::getEndColumn | ( | ) |  |

pure virtual

Returns the column number of the last character for current token (being matched after the last call to BeginToken).

Implemented in Lucene::FastCharStream.

virtual int32_t Lucene::QueryParserCharStream::getEndLine | ( | ) |  |

pure virtual

Returns the line number of the last character for current token (being matched after the last call to BeginToken).

Implemented in Lucene::FastCharStream.

virtual String Lucene::QueryParserCharStream::GetImage | ( | ) |  |

pure virtual

Returns a string made up of characters from the marked token beginning to the current buffer position. Implementations have the choice of returning anything that they want to. For example, for efficiency, one might decide to just return null, which is a valid implementation.

Implemented in Lucene::FastCharStream.

virtual int32_t Lucene::QueryParserCharStream::getLine | ( | ) |  |

pure virtual

Returns the line number of the character last read.

Deprecated:

See Also
  getEndLine

Implemented in Lucene::FastCharStream.

virtual CharArray Lucene::QueryParserCharStream::GetSuffix | ( | int32_t | length) |  |

pure virtual

Returns an array of characters that make up the suffix of length for the currently matched token. This is used to build up the matched string for use in actions in the case of MORE.

Implemented in Lucene::FastCharStream.

virtual wchar_t Lucene::QueryParserCharStream::readChar | ( | ) |  |

pure virtual

Returns the next character from the selected input. The method of selecting the input is the responsibility of the class implementing this interface.

Implemented in Lucene::FastCharStream.

The documentation for this class was generated from the following file:

- QueryParserCharStream.h

clucene.sourceforge.net